diff --git a/tools/virtiofsd/fuse_lowlevel.c b/tools/virtiofsd/fuse_lowlevel.c
index 497eb25487..f4bd303a7a 100644
--- a/tools/virtiofsd/fuse_lowlevel.c
+++ b/tools/virtiofsd/fuse_lowlevel.c
@@ -387,16 +387,7 @@ static void fill_open(struct fuse_open_out *arg, const struct fuse_file_info *f)
 int fuse_reply_entry(fuse_req_t req, const struct fuse_entry_param *e)
 {
     struct fuse_entry_out arg;
-    size_t size = req->se->conn.proto_minor < 9 ? FUSE_COMPAT_ENTRY_OUT_SIZE :
-                                                  sizeof(arg);
-
-    /*
-     * before ABI 7.4 e->ino == 0 was invalid, only ENOENT meant
-     * negative entry
-     */
-    if (!e->ino && req->se->conn.proto_minor < 4) {
-        return fuse_reply_err(req, ENOENT);
-    }
+    size_t size = sizeof(arg);
 
     memset(&arg, 0, sizeof(arg));
     fill_entry(&arg, e);
@@ -407,9 +398,7 @@ int fuse_reply_create(fuse_req_t req, const struct fuse_entry_param *e,
                       const struct fuse_file_info *f)
 {
     char buf[sizeof(struct fuse_entry_out) + sizeof(struct fuse_open_out)];
-    size_t entrysize = req->se->conn.proto_minor < 9 ?
-                           FUSE_COMPAT_ENTRY_OUT_SIZE :
-                           sizeof(struct fuse_entry_out);
+    size_t entrysize = sizeof(struct fuse_entry_out);
     struct fuse_entry_out *earg = (struct fuse_entry_out *)buf;
     struct fuse_open_out *oarg = (struct fuse_open_out *)(buf + entrysize);
 
@@ -423,8 +412,7 @@ int fuse_reply_attr(fuse_req_t req, const struct stat *attr,
                     double attr_timeout)
 {
     struct fuse_attr_out arg;
-    size_t size =
-        req->se->conn.proto_minor < 9 ? FUSE_COMPAT_ATTR_OUT_SIZE : sizeof(arg);
+    size_t size = sizeof(arg);
 
     memset(&arg, 0, sizeof(arg));
     arg.attr_valid = calc_timeout_sec(attr_timeout);
@@ -521,8 +509,7 @@ int fuse_reply_data(fuse_req_t req, struct fuse_bufvec *bufv,
 int fuse_reply_statfs(fuse_req_t req, const struct statvfs *stbuf)
 {
     struct fuse_statfs_out arg;
-    size_t size =
-        req->se->conn.proto_minor < 4 ? FUSE_COMPAT_STATFS_SIZE : sizeof(arg);
+    size_t size = sizeof(arg);
 
     memset(&arg, 0, sizeof(arg));
     convert_statfs(stbuf, &arg.st);
@@ -606,45 +593,31 @@ int fuse_reply_ioctl_retry(fuse_req_t req, const struct iovec *in_iov,
     iov[count].iov_len = sizeof(arg);
     count++;
 
-    if (req->se->conn.proto_minor < 16) {
-        if (in_count) {
-            iov[count].iov_base = (void *)in_iov;
-            iov[count].iov_len = sizeof(in_iov[0]) * in_count;
-            count++;
-        }
+    /* Can't handle non-compat 64bit ioctls on 32bit */
+    if (sizeof(void *) == 4 && req->ioctl_64bit) {
+        res = fuse_reply_err(req, EINVAL);
+        goto out;
+    }
 
-        if (out_count) {
-            iov[count].iov_base = (void *)out_iov;
-            iov[count].iov_len = sizeof(out_iov[0]) * out_count;
-            count++;
+    if (in_count) {
+        in_fiov = fuse_ioctl_iovec_copy(in_iov, in_count);
+        if (!in_fiov) {
+            goto enomem;
         }
-    } else {
-        /* Can't handle non-compat 64bit ioctls on 32bit */
-        if (sizeof(void *) == 4 && req->ioctl_64bit) {
-            res = fuse_reply_err(req, EINVAL);
-            goto out;
-        }
-
-        if (in_count) {
-            in_fiov = fuse_ioctl_iovec_copy(in_iov, in_count);
-            if (!in_fiov) {
-                goto enomem;
-            }
 
-            iov[count].iov_base = (void *)in_fiov;
-            iov[count].iov_len = sizeof(in_fiov[0]) * in_count;
-            count++;
+        iov[count].iov_base = (void *)in_fiov;
+        iov[count].iov_len = sizeof(in_fiov[0]) * in_count;
+        count++;
+    }
+    if (out_count) {
+        out_fiov = fuse_ioctl_iovec_copy(out_iov, out_count);
+        if (!out_fiov) {
+            goto enomem;
         }
-        if (out_count) {
-            out_fiov = fuse_ioctl_iovec_copy(out_iov, out_count);
-            if (!out_fiov) {
-                goto enomem;
-            }
 
-            iov[count].iov_base = (void *)out_fiov;
-            iov[count].iov_len = sizeof(out_fiov[0]) * out_count;
-            count++;
-        }
+        iov[count].iov_base = (void *)out_fiov;
+        iov[count].iov_len = sizeof(out_fiov[0]) * out_count;
+        count++;
     }
 
     res = send_reply_iov(req, 0, iov, count);
@@ -786,14 +759,12 @@ static void do_getattr(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
     struct fuse_file_info *fip = NULL;
     struct fuse_file_info fi;
 
-    if (req->se->conn.proto_minor >= 9) {
-        struct fuse_getattr_in *arg = (struct fuse_getattr_in *)inarg;
+    struct fuse_getattr_in *arg = (struct fuse_getattr_in *)inarg;
 
-        if (arg->getattr_flags & FUSE_GETATTR_FH) {
-            memset(&fi, 0, sizeof(fi));
-            fi.fh = arg->fh;
-            fip = &fi;
-        }
+    if (arg->getattr_flags & FUSE_GETATTR_FH) {
+        memset(&fi, 0, sizeof(fi));
+        fi.fh = arg->fh;
+        fip = &fi;
     }
 
     if (req->se->op.getattr) {
@@ -858,11 +829,7 @@ static void do_mknod(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
     struct fuse_mknod_in *arg = (struct fuse_mknod_in *)inarg;
     char *name = PARAM(arg);
 
-    if (req->se->conn.proto_minor >= 12) {
-        req->ctx.umask = arg->umask;
-    } else {
-        name = (char *)inarg + FUSE_COMPAT_MKNOD_IN_SIZE;
-    }
+    req->ctx.umask = arg->umask;
 
     if (req->se->op.mknod) {
         req->se->op.mknod(req, nodeid, name, arg->mode, arg->rdev);
@@ -875,9 +842,7 @@ static void do_mkdir(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
 {
     struct fuse_mkdir_in *arg = (struct fuse_mkdir_in *)inarg;
 
-    if (req->se->conn.proto_minor >= 12) {
-        req->ctx.umask = arg->umask;
-    }
+    req->ctx.umask = arg->umask;
 
     if (req->se->op.mkdir) {
         req->se->op.mkdir(req, nodeid, PARAM(arg), arg->mode);
@@ -969,11 +934,7 @@ static void do_create(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
         memset(&fi, 0, sizeof(fi));
         fi.flags = arg->flags;
 
-        if (req->se->conn.proto_minor >= 12) {
-            req->ctx.umask = arg->umask;
-        } else {
-            name = (char *)inarg + sizeof(struct fuse_open_in);
-        }
+        req->ctx.umask = arg->umask;
 
         req->se->op.create(req, nodeid, name, arg->mode, &fi);
     } else {
@@ -1005,10 +966,8 @@ static void do_read(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
 
         memset(&fi, 0, sizeof(fi));
         fi.fh = arg->fh;
-        if (req->se->conn.proto_minor >= 9) {
-            fi.lock_owner = arg->lock_owner;
-            fi.flags = arg->flags;
-        }
+        fi.lock_owner = arg->lock_owner;
+        fi.flags = arg->flags;
         req->se->op.read(req, nodeid, arg->size, arg->offset, &fi);
     } else {
         fuse_reply_err(req, ENOSYS);
@@ -1025,13 +984,9 @@ static void do_write(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
     fi.fh = arg->fh;
     fi.writepage = (arg->write_flags & FUSE_WRITE_CACHE) != 0;
 
-    if (req->se->conn.proto_minor < 9) {
-        param = ((char *)arg) + FUSE_COMPAT_WRITE_IN_SIZE;
-    } else {
-        fi.lock_owner = arg->lock_owner;
-        fi.flags = arg->flags;
-        param = PARAM(arg);
-    }
+    fi.lock_owner = arg->lock_owner;
+    fi.flags = arg->flags;
+    param = PARAM(arg);
 
     if (req->se->op.write) {
         req->se->op.write(req, nodeid, param, arg->size, arg->offset, &fi);
@@ -1055,21 +1010,14 @@ static void do_write_buf(fuse_req_t req, fuse_ino_t nodeid, const void *inarg,
     fi.fh = arg->fh;
     fi.writepage = arg->write_flags & FUSE_WRITE_CACHE;
 
-    if (se->conn.proto_minor < 9) {
-        bufv.buf[0].mem = ((char *)arg) + FUSE_COMPAT_WRITE_IN_SIZE;
-        bufv.buf[0].size -=
-            sizeof(struct fuse_in_header) + FUSE_COMPAT_WRITE_IN_SIZE;
-        assert(!(bufv.buf[0].flags & FUSE_BUF_IS_FD));
-    } else {
-        fi.lock_owner = arg->lock_owner;
-        fi.flags = arg->flags;
-        if (!(bufv.buf[0].flags & FUSE_BUF_IS_FD)) {
-            bufv.buf[0].mem = PARAM(arg);
-        }
-
-        bufv.buf[0].size -=
-            sizeof(struct fuse_in_header) + sizeof(struct fuse_write_in);
+    fi.lock_owner = arg->lock_owner;
+    fi.flags = arg->flags;
+    if (!(bufv.buf[0].flags & FUSE_BUF_IS_FD)) {
+        bufv.buf[0].mem = PARAM(arg);
     }
+
+    bufv.buf[0].size -=
+        sizeof(struct fuse_in_header) + sizeof(struct fuse_write_in);
     if (bufv.buf[0].size < arg->size) {
         fuse_log(FUSE_LOG_ERR, "fuse: do_write_buf: buffer size too small\n");
         fuse_reply_err(req, EIO);
@@ -1088,9 +1036,7 @@ static void do_flush(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
     memset(&fi, 0, sizeof(fi));
     fi.fh = arg->fh;
     fi.flush = 1;
-    if (req->se->conn.proto_minor >= 7) {
-        fi.lock_owner = arg->lock_owner;
-    }
+    fi.lock_owner = arg->lock_owner;
 
     if (req->se->op.flush) {
         req->se->op.flush(req, nodeid, &fi);
@@ -1107,10 +1053,8 @@ static void do_release(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
     memset(&fi, 0, sizeof(fi));
     fi.flags = arg->flags;
     fi.fh = arg->fh;
-    if (req->se->conn.proto_minor >= 8) {
-        fi.flush = (arg->release_flags & FUSE_RELEASE_FLUSH) ? 1 : 0;
-        fi.lock_owner = arg->lock_owner;
-    }
+    fi.flush = (arg->release_flags & FUSE_RELEASE_FLUSH) ? 1 : 0;
+    fi.lock_owner = arg->lock_owner;
     if (arg->release_flags & FUSE_RELEASE_FLOCK_UNLOCK) {
         fi.flock_release = 1;
         fi.lock_owner = arg->lock_owner;
@@ -1479,8 +1423,7 @@ static void do_ioctl(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
     memset(&fi, 0, sizeof(fi));
     fi.fh = arg->fh;
 
-    if (sizeof(void *) == 4 && req->se->conn.proto_minor >= 16 &&
-        !(flags & FUSE_IOCTL_32BIT)) {
+    if (sizeof(void *) == 4 && !(flags & FUSE_IOCTL_32BIT)) {
         req->ioctl_64bit = 1;
     }
 
@@ -1605,7 +1548,7 @@ static void do_init(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
     outarg.major = FUSE_KERNEL_VERSION;
     outarg.minor = FUSE_KERNEL_MINOR_VERSION;
 
-    if (arg->major < 7) {
+    if (arg->major < 7 || (arg->major == 7 && arg->minor < 31)) {
         fuse_log(FUSE_LOG_ERR, "fuse: unsupported protocol version: %u.%u\n",
                  arg->major, arg->minor);
         fuse_reply_err(req, EPROTO);
@@ -1618,81 +1561,71 @@ static void do_init(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
         return;
     }
 
-    if (arg->minor >= 6) {
-        if (arg->max_readahead < se->conn.max_readahead) {
-            se->conn.max_readahead = arg->max_readahead;
-        }
-        if (arg->flags & FUSE_ASYNC_READ) {
-            se->conn.capable |= FUSE_CAP_ASYNC_READ;
-        }
-        if (arg->flags & FUSE_POSIX_LOCKS) {
-            se->conn.capable |= FUSE_CAP_POSIX_LOCKS;
-        }
-        if (arg->flags & FUSE_ATOMIC_O_TRUNC) {
-            se->conn.capable |= FUSE_CAP_ATOMIC_O_TRUNC;
-        }
-        if (arg->flags & FUSE_EXPORT_SUPPORT) {
-            se->conn.capable |= FUSE_CAP_EXPORT_SUPPORT;
-        }
-        if (arg->flags & FUSE_DONT_MASK) {
-            se->conn.capable |= FUSE_CAP_DONT_MASK;
-        }
-        if (arg->flags & FUSE_FLOCK_LOCKS) {
-            se->conn.capable |= FUSE_CAP_FLOCK_LOCKS;
-        }
-        if (arg->flags & FUSE_AUTO_INVAL_DATA) {
-            se->conn.capable |= FUSE_CAP_AUTO_INVAL_DATA;
-        }
-        if (arg->flags & FUSE_DO_READDIRPLUS) {
-            se->conn.capable |= FUSE_CAP_READDIRPLUS;
-        }
-        if (arg->flags & FUSE_READDIRPLUS_AUTO) {
-            se->conn.capable |= FUSE_CAP_READDIRPLUS_AUTO;
-        }
-        if (arg->flags & FUSE_ASYNC_DIO) {
-            se->conn.capable |= FUSE_CAP_ASYNC_DIO;
-        }
-        if (arg->flags & FUSE_WRITEBACK_CACHE) {
-            se->conn.capable |= FUSE_CAP_WRITEBACK_CACHE;
-        }
-        if (arg->flags & FUSE_NO_OPEN_SUPPORT) {
-            se->conn.capable |= FUSE_CAP_NO_OPEN_SUPPORT;
-        }
-        if (arg->flags & FUSE_PARALLEL_DIROPS) {
-            se->conn.capable |= FUSE_CAP_PARALLEL_DIROPS;
-        }
-        if (arg->flags & FUSE_POSIX_ACL) {
-            se->conn.capable |= FUSE_CAP_POSIX_ACL;
-        }
-        if (arg->flags & FUSE_HANDLE_KILLPRIV) {
-            se->conn.capable |= FUSE_CAP_HANDLE_KILLPRIV;
-        }
-        if (arg->flags & FUSE_NO_OPENDIR_SUPPORT) {
-            se->conn.capable |= FUSE_CAP_NO_OPENDIR_SUPPORT;
-        }
-        if (!(arg->flags & FUSE_MAX_PAGES)) {
-            size_t max_bufsize =
-                FUSE_DEFAULT_MAX_PAGES_PER_REQ * getpagesize() +
-                FUSE_BUFFER_HEADER_SIZE;
-            if (bufsize > max_bufsize) {
-                bufsize = max_bufsize;
-            }
+    if (arg->max_readahead < se->conn.max_readahead) {
+        se->conn.max_readahead = arg->max_readahead;
+    }
+    if (arg->flags & FUSE_ASYNC_READ) {
+        se->conn.capable |= FUSE_CAP_ASYNC_READ;
+    }
+    if (arg->flags & FUSE_POSIX_LOCKS) {
+        se->conn.capable |= FUSE_CAP_POSIX_LOCKS;
+    }
+    if (arg->flags & FUSE_ATOMIC_O_TRUNC) {
+        se->conn.capable |= FUSE_CAP_ATOMIC_O_TRUNC;
+    }
+    if (arg->flags & FUSE_EXPORT_SUPPORT) {
+        se->conn.capable |= FUSE_CAP_EXPORT_SUPPORT;
+    }
+    if (arg->flags & FUSE_DONT_MASK) {
+        se->conn.capable |= FUSE_CAP_DONT_MASK;
+    }
+    if (arg->flags & FUSE_FLOCK_LOCKS) {
+        se->conn.capable |= FUSE_CAP_FLOCK_LOCKS;
+    }
+    if (arg->flags & FUSE_AUTO_INVAL_DATA) {
+        se->conn.capable |= FUSE_CAP_AUTO_INVAL_DATA;
+    }
+    if (arg->flags & FUSE_DO_READDIRPLUS) {
+        se->conn.capable |= FUSE_CAP_READDIRPLUS;
+    }
+    if (arg->flags & FUSE_READDIRPLUS_AUTO) {
+        se->conn.capable |= FUSE_CAP_READDIRPLUS_AUTO;
+    }
+    if (arg->flags & FUSE_ASYNC_DIO) {
+        se->conn.capable |= FUSE_CAP_ASYNC_DIO;
+    }
+    if (arg->flags & FUSE_WRITEBACK_CACHE) {
+        se->conn.capable |= FUSE_CAP_WRITEBACK_CACHE;
+    }
+    if (arg->flags & FUSE_NO_OPEN_SUPPORT) {
+        se->conn.capable |= FUSE_CAP_NO_OPEN_SUPPORT;
+    }
+    if (arg->flags & FUSE_PARALLEL_DIROPS) {
+        se->conn.capable |= FUSE_CAP_PARALLEL_DIROPS;
+    }
+    if (arg->flags & FUSE_POSIX_ACL) {
+        se->conn.capable |= FUSE_CAP_POSIX_ACL;
+    }
+    if (arg->flags & FUSE_HANDLE_KILLPRIV) {
+        se->conn.capable |= FUSE_CAP_HANDLE_KILLPRIV;
+    }
+    if (arg->flags & FUSE_NO_OPENDIR_SUPPORT) {
+        se->conn.capable |= FUSE_CAP_NO_OPENDIR_SUPPORT;
+    }
+    if (!(arg->flags & FUSE_MAX_PAGES)) {
+        size_t max_bufsize = FUSE_DEFAULT_MAX_PAGES_PER_REQ * getpagesize() +
+                             FUSE_BUFFER_HEADER_SIZE;
+        if (bufsize > max_bufsize) {
+            bufsize = max_bufsize;
         }
-    } else {
-        se->conn.max_readahead = 0;
     }
-
-    if (se->conn.proto_minor >= 14) {
 #ifdef HAVE_SPLICE
 #ifdef HAVE_VMSPLICE
-        se->conn.capable |= FUSE_CAP_SPLICE_WRITE | FUSE_CAP_SPLICE_MOVE;
+    se->conn.capable |= FUSE_CAP_SPLICE_WRITE | FUSE_CAP_SPLICE_MOVE;
 #endif
-        se->conn.capable |= FUSE_CAP_SPLICE_READ;
+    se->conn.capable |= FUSE_CAP_SPLICE_READ;
 #endif
-    }
-    if (se->conn.proto_minor >= 18) {
-        se->conn.capable |= FUSE_CAP_IOCTL_DIR;
-    }
+    se->conn.capable |= FUSE_CAP_IOCTL_DIR;
 
     /*
      * Default settings for modern filesystems.
@@ -1799,24 +1732,20 @@ static void do_init(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
     }
     outarg.max_readahead = se->conn.max_readahead;
     outarg.max_write = se->conn.max_write;
-    if (se->conn.proto_minor >= 13) {
-        if (se->conn.max_background >= (1 << 16)) {
-            se->conn.max_background = (1 << 16) - 1;
-        }
-        if (se->conn.congestion_threshold > se->conn.max_background) {
-            se->conn.congestion_threshold = se->conn.max_background;
-        }
-        if (!se->conn.congestion_threshold) {
-            se->conn.congestion_threshold = se->conn.max_background * 3 / 4;
-        }
-
-        outarg.max_background = se->conn.max_background;
-        outarg.congestion_threshold = se->conn.congestion_threshold;
+    if (se->conn.max_background >= (1 << 16)) {
+        se->conn.max_background = (1 << 16) - 1;
+    }
+    if (se->conn.congestion_threshold > se->conn.max_background) {
+        se->conn.congestion_threshold = se->conn.max_background;
     }
-    if (se->conn.proto_minor >= 23) {
-        outarg.time_gran = se->conn.time_gran;
+    if (!se->conn.congestion_threshold) {
+        se->conn.congestion_threshold = se->conn.max_background * 3 / 4;
     }
 
+    outarg.max_background = se->conn.max_background;
+    outarg.congestion_threshold = se->conn.congestion_threshold;
+    outarg.time_gran = se->conn.time_gran;
+
     if (se->debug) {
         fuse_log(FUSE_LOG_DEBUG, "   INIT: %u.%u\n", outarg.major,
                  outarg.minor);
@@ -1830,11 +1759,6 @@ static void do_init(fuse_req_t req, fuse_ino_t nodeid, const void *inarg)
                  outarg.congestion_threshold);
         fuse_log(FUSE_LOG_DEBUG, "   time_gran=%u\n", outarg.time_gran);
     }
-    if (arg->minor < 5) {
-        outargsize = FUSE_COMPAT_INIT_OUT_SIZE;
-    } else if (arg->minor < 23) {
-        outargsize = FUSE_COMPAT_22_INIT_OUT_SIZE;
-    }
 
     send_reply_ok(req, &outarg, outargsize);
 }
@@ -1898,10 +1822,6 @@ int fuse_lowlevel_notify_inval_inode(struct fuse_session *se, fuse_ino_t ino,
         return -EINVAL;
     }
 
-    if (se->conn.proto_major < 6 || se->conn.proto_minor < 12) {
-        return -ENOSYS;
-    }
-
     outarg.ino = ino;
     outarg.off = off;
     outarg.len = len;
@@ -1922,10 +1842,6 @@ int fuse_lowlevel_notify_inval_entry(struct fuse_session *se, fuse_ino_t parent,
         return -EINVAL;
     }
 
-    if (se->conn.proto_major < 6 || se->conn.proto_minor < 12) {
-        return -ENOSYS;
-    }
-
     outarg.parent = parent;
     outarg.namelen = namelen;
     outarg.padding = 0;
@@ -1949,10 +1865,6 @@ int fuse_lowlevel_notify_delete(struct fuse_session *se, fuse_ino_t parent,
         return -EINVAL;
     }
 
-    if (se->conn.proto_major < 6 || se->conn.proto_minor < 18) {
-        return -ENOSYS;
-    }
-
     outarg.parent = parent;
     outarg.child = child;
     outarg.namelen = namelen;
@@ -1980,10 +1892,6 @@ int fuse_lowlevel_notify_store(struct fuse_session *se, fuse_ino_t ino,
         return -EINVAL;
     }
 
-    if (se->conn.proto_major < 6 || se->conn.proto_minor < 15) {
-        return -ENOSYS;
-    }
-
     out.unique = 0;
     out.error = FUSE_NOTIFY_STORE;
 